Program Eta_modeling

  use sep
  use ani_dotst
  use ani_type
  use ani_parms
  use ani_exec_time
  use ani_taper
  use eta_pspi
  use base_fftwfl_mod

  implicit none

  real						        :: start, finish,start1,finish1, o3,a
  integer					        :: iw,iz,ix,it,plan,nw
  real, allocatable					:: taper(:)
  real, allocatable					:: wfld(:,:,:)
  real, allocatable					:: trace(:), model(:,:,:), refr(:,:,:)
  complex, allocatable       			     	:: temp(:),source(:,:),source1(:)
  complex,allocatable					:: wfld_w(:,:,:)
  
  call sep_init()
  call sep_begin_prog()

  ! ================================================================================================
  ! Initialization 
  
  call aniparam()

  nw = rec%w%n
  ! Model and reference model
  allocate(model(mdl%z%n,mdl%xm%n,npar))
write(0,*) "model dimension", mdl%z%n, mdl%xm%n, npar
  call sreed("mdl", model, 4*mdl%z%n*mdl%xm%n*npar)
write(0,*) "reference model dimension", ref%z%n,nref_max,npar
  allocate(refr(ref%z%n, nref_max, npar))
  call sreed("ref", refr, 4*ref%z%n*nref_max*npar)

  ! Source and receiver
  allocate(source1(sou%w%n))
  call sreed("sou", source1, 8*sou%w%n)
  allocate(source(mdl%xm%n,sou%w%n))
  source=0.; source(mdl%xm%n/2,:)=source1;
  deallocate(source1)

  allocate(temp(nx), wfld_w(nz, nx, rec%w%n))
  temp=0.; wfld_w = 0.
  do iw = 2, rec%w%n
     temp = source(:,iw)
     do iz=1, nz
        call etapspi(iw, 1, 1, temp, model(iz,:,:), refr(iz,:,:), "sou")
        wfld_w(iz,:,iw) = wfld_w(iz,:,iw) + temp
     end do
  end do
  deallocate(temp)
  allocate(temp(nw))
  allocate(trace(nx), wfld(nz,nx,nt))
  trace = 0.; wfld = 0.
  call sfftw_plan_dft_c2r_1d(plan, nt, temp, trace, FFTW_ESTIMATE)
  do ix = 1, nx
     do iz = 1, nz
        temp = wfld_w(iz,ix,:)
        call sfftw_execute(plan)
        do it = 1, nt
           wfld(iz,ix,it) = trace(it)*(1./nt)
        end do
     end do
  end do
  call sep_write(wfld)

  call to_history("n1",nz) ; call to_history("d1",dz) ; call to_history("o1",oz)
  call to_history("n2",nx) ; call to_history("d2",dx) ; call to_history("o2",ox)
  call to_history("n3",nt); call to_history("d3",dt); call to_history("o3",ot)  
  
  deallocate(wfld, wfld_w, trace, temp, source, model, refr)

end Program Eta_modeling
